



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>转 InnoDB索引</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">转 InnoDB索引</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 20:07:56 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文： http://blog.codinglabs.org/articles/theory-of-mysql-index.html</p>
<h2>InnoDB索引实现</h2>
<p>虽然InnoDB也使用B+Tree作为索引结构，但具体实现方式却与MyISAM截然不同。</p>
<p>第一个重大区别是InnoDB的数据文件本身就是索引文件。从上文知道，MyISAM索引文件和数据文件是分离的，索引文件仅保存数据记录的地址。 而在InnoDB中，表数据文件本身就是按B+Tree组织的一个索引结构，这棵树的叶节点data域保存了完整的数据记录。这个索引的key是数据表的 主键，因此InnoDB表数据文件本身就是主索引。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/358920/201511/358920-20151116111410140-396664832.png" /></p>
<p>图10是InnoDB主索引（同时也是数据文件）的示意图，可以看到叶节点包含了完整的数据记录。这种索引叫做聚集索引。因为InnoDB的数据文 件本身要按主键聚集，所以InnoDB要求表必须有主键（MyISAM可以没有），如果没有显式指定，则MySQL系统会自动选择一个可以唯一标识数据记 录的列作为主键，如果不存在这种列，则MySQL自动为InnoDB表生成一个隐含字段作为主键，这个字段长度为6个字节，类型为长整形。</p>
<p>第二个与MyISAM索引的不同是InnoDB的辅助索引data域存储相应记录主键的值而不是地址。换句话说，InnoDB的所有辅助索引都引用主键作为data域。例如，图11为定义在Col3上的一个辅助索引：</p>
<p>这里以英文字符的ASCII码作为比较准则。聚集索引这种实现方式使得按主键的搜索十分高效，但是辅助索引搜索需要检索两遍索引：首先检索辅助索引获得主键，然后用主键到主索引中检索获得记录。</p>
<p>了解不同存储引擎的索引实现方式对于正确使用和优化索引都非常有帮助，例如知道了InnoDB的索引实现后，就很容易明白为什么不建议使用过长的字 段作为主键，因为所有辅助索引都引用主索引，过长的主索引会令辅助索引变得过大。再例如，用非单调的字段作为主键在InnoDB中不是个好主意，因为 InnoDB数据文件本身是一颗B+Tree，非单调的主键会造成在插入新记录时数据文件为了维持B+Tree的特性而频繁的分裂调整，十分低效，而使用 自增字段作为主键则是一个很好的选择。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q77mvxq.html">R读取溢出的数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8og35pq.html">STM32下载调试驱动问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvodox8.html">cas</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql0220q.html">Ubantu16&period;4的安装过程以及基本配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdylzzq.html">XML的Pull解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ez0vz8.html">与众不同 windows phone &lpar;35&rpar; - 8&period;0 新的启动器&colon; ShareMediaTask&comma; SaveAppointmentTask&comma; MapsTask&comma; MapsDirectionsTask&comma; MapDownloaderTask</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw6n2r9.html">安装tar&period;bz2文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnn530q.html">MySql的导入与导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1oe639.html">暴力枚举&mdash;&mdash;Help Me with the Game</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k15jx39.html">PHP header 的几种用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn5x1d8.html">lintcode ：nth to Last Node In List 链表倒数第n个节点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1zkyj9.html">Delphi 颜色转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0od3wq.html">IOS学习教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wpy2vq.html">python学习（四）五数连珠</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxorz8.html">使用 Spring RestTemplate 调用 rest 服务时自定义请求头（custom HTTP headers）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p3v738.html">HDU 1896 Stones &lpar;优先队列&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjoojl8.html">Flask -- 消息闪现、错误处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexj22q.html">window&period;open&lpar;&rpar;被拦截问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wj5zwq.html">nodejs的某些api~（三）net模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kw719.html">自动生成简单四则运算的C语言程序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96p1zyy8.html">Numpy系列（五）- 复制和视图</a>
			</li>
						<li><a href="https://www.batexi.com/a/8megrgoq.html">Java Web之Cookie、Session</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z4jkg9.html">用 python 写一个年会抽奖小程序</a>
			</li>
						<li><a href="https://www.batexi.com/a/8megxgoq.html">解决 IIS 反向代理ARR URLREWRITE 设置后，不能跨域跳转 return Redirect 问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk1rk08.html">DevExpress 控件汉化方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1plrjq.html">常见的游戏AI技术对比&lpar;FSM&comma;HFSM&comma;BT&comma;GOAP&comma;HTN&comma;Utilitay&comma;机器学习&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gel6ye8.html">使用HttpClient和WebRequest时POST一个对象的写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdz52k9.html">51nod 1016 水仙花数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jr11o8.html">adb devices 报错处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj3zkk8.html">易度文档管理系统--http&colon;&sol;&sol;www&period;everydo&period;com&sol;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
